
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class OrdersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const orders = await db.orders.create(
            {
                id: data.id || undefined,
        
        order_number: data.order_number
        ||
        null
            ,
            
        order_status: data.order_status
        ||
        null
            ,
            
        financial_status: data.financial_status
        ||
        null
            ,
            
        fulfillment_status: data.fulfillment_status
        ||
        null
            ,
            
        subtotal_price: data.subtotal_price
        ||
        null
            ,
            
        shipping_price: data.shipping_price
        ||
        null
            ,
            
        tax_price: data.tax_price
        ||
        null
            ,
            
        discount_total: data.discount_total
        ||
        null
            ,
            
        total_price: data.total_price
        ||
        null
            ,
            
        currency_code: data.currency_code
        ||
        null
            ,
            
        placed_at: data.placed_at
        ||
        null
            ,
            
        cancelled_at: data.cancelled_at
        ||
        null
            ,
            
        cancel_reason: data.cancel_reason
        ||
        null
            ,
            
        internal_note: data.internal_note
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await orders.setStore( data.store || null, {
            transaction,
        });
        
        await orders.setCustomer( data.customer || null, {
            transaction,
        });
        
        await orders.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return orders;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ordersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                order_number: item.order_number
            ||
            null
            ,
            
                order_status: item.order_status
            ||
            null
            ,
            
                financial_status: item.financial_status
            ||
            null
            ,
            
                fulfillment_status: item.fulfillment_status
            ||
            null
            ,
            
                subtotal_price: item.subtotal_price
            ||
            null
            ,
            
                shipping_price: item.shipping_price
            ||
            null
            ,
            
                tax_price: item.tax_price
            ||
            null
            ,
            
                discount_total: item.discount_total
            ||
            null
            ,
            
                total_price: item.total_price
            ||
            null
            ,
            
                currency_code: item.currency_code
            ||
            null
            ,
            
                placed_at: item.placed_at
            ||
            null
            ,
            
                cancelled_at: item.cancelled_at
            ||
            null
            ,
            
                cancel_reason: item.cancel_reason
            ||
            null
            ,
            
                internal_note: item.internal_note
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const orders = await db.orders.bulkCreate(ordersData, { transaction });

        // For each item created, replace relation files
        

        return orders;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const orders = await db.orders.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.order_number !== undefined) updatePayload.order_number = data.order_number;
        
        
        if (data.order_status !== undefined) updatePayload.order_status = data.order_status;
        
        
        if (data.financial_status !== undefined) updatePayload.financial_status = data.financial_status;
        
        
        if (data.fulfillment_status !== undefined) updatePayload.fulfillment_status = data.fulfillment_status;
        
        
        if (data.subtotal_price !== undefined) updatePayload.subtotal_price = data.subtotal_price;
        
        
        if (data.shipping_price !== undefined) updatePayload.shipping_price = data.shipping_price;
        
        
        if (data.tax_price !== undefined) updatePayload.tax_price = data.tax_price;
        
        
        if (data.discount_total !== undefined) updatePayload.discount_total = data.discount_total;
        
        
        if (data.total_price !== undefined) updatePayload.total_price = data.total_price;
        
        
        if (data.currency_code !== undefined) updatePayload.currency_code = data.currency_code;
        
        
        if (data.placed_at !== undefined) updatePayload.placed_at = data.placed_at;
        
        
        if (data.cancelled_at !== undefined) updatePayload.cancelled_at = data.cancelled_at;
        
        
        if (data.cancel_reason !== undefined) updatePayload.cancel_reason = data.cancel_reason;
        
        
        if (data.internal_note !== undefined) updatePayload.internal_note = data.internal_note;
        
        
        updatePayload.updatedById = currentUser.id;

        await orders.update(updatePayload, {transaction});

        
        
        if (data.store !== undefined) {
            await orders.setStore(
              
              data.store,
              
              { transaction }
            );
        }
        
        if (data.customer !== undefined) {
            await orders.setCustomer(
              
              data.customer,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await orders.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return orders;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const orders = await db.orders.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of orders) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of orders) {
                await record.destroy({transaction});
            }
        });


        return orders;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const orders = await db.orders.findByPk(id, options);

        await orders.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await orders.destroy({
            transaction
        });

        return orders;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const orders = await db.orders.findOne(
            { where },
            { transaction },
        );

        if (!orders) {
            return orders;
        }

        const output = orders.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        output.order_items_order = await orders.getOrder_items_order({
            transaction
        });
        
        
        output.fulfillments_order = await orders.getFulfillments_order({
            transaction
        });
        
        
        output.payments_order = await orders.getPayments_order({
            transaction
        });
        
        
        
        output.refunds_order = await orders.getRefunds_order({
            transaction
        });
        
        
        
        
        
        
        
        output.support_tickets_order = await orders.getSupport_tickets_order({
            transaction
        });
        
        
        
        
        output.store = await orders.getStore({
            transaction
        });
        
        
        output.customer = await orders.getCustomer({
            transaction
        });
        
        
        output.organizations = await orders.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.stores,
        as: 'store',
        
        where: filter.store ? {
          [Op.or]: [
            { id: { [Op.in]: filter.store.split('|').map(term => Utils.uuid(term)) } },
            {
              store_name: {
                [Op.or]: filter.store.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.customers,
        as: 'customer',
        
        where: filter.customer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.customer.split('|').map(term => Utils.uuid(term)) } },
            {
              email: {
                [Op.or]: filter.customer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.order_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'orders',
                        'order_number',
                        filter.order_number,
                    ),
                };
            }
            
            if (filter.currency_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'orders',
                        'currency_code',
                        filter.currency_code,
                    ),
                };
            }
            
            if (filter.cancel_reason) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'orders',
                        'cancel_reason',
                        filter.cancel_reason,
                    ),
                };
            }
            
            if (filter.internal_note) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'orders',
                        'internal_note',
                        filter.internal_note,
                    ),
                };
            }
            

            
            

            
            if (filter.subtotal_priceRange) {
                const [start, end] = filter.subtotal_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    subtotal_price: {
                    ...where.subtotal_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    subtotal_price: {
                    ...where.subtotal_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.shipping_priceRange) {
                const [start, end] = filter.shipping_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    shipping_price: {
                    ...where.shipping_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    shipping_price: {
                    ...where.shipping_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.tax_priceRange) {
                const [start, end] = filter.tax_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tax_price: {
                    ...where.tax_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tax_price: {
                    ...where.tax_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.discount_totalRange) {
                const [start, end] = filter.discount_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    discount_total: {
                    ...where.discount_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    discount_total: {
                    ...where.discount_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_priceRange) {
                const [start, end] = filter.total_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_price: {
                    ...where.total_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_price: {
                    ...where.total_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.placed_atRange) {
                const [start, end] = filter.placed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    placed_at: {
                    ...where.placed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    placed_at: {
                    ...where.placed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.cancelled_atRange) {
                const [start, end] = filter.cancelled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    cancelled_at: {
                    ...where.cancelled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    cancelled_at: {
                    ...where.cancelled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.order_status) {
                where = {
                    ...where,
                order_status: filter.order_status,
            };
            }
            
            if (filter.financial_status) {
                where = {
                    ...where,
                financial_status: filter.financial_status,
            };
            }
            
            if (filter.fulfillment_status) {
                where = {
                    ...where,
                fulfillment_status: filter.fulfillment_status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.orders.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'orders',
                        'order_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.orders.findAll({
            attributes: [ 'id', 'order_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['order_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.order_number,
        }));
    }

    
};

